/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.geodata.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.geodata.entity.GeodataOrt;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractGeodataOrtSearch {

  @Inject
  protected transient GeodataOrtExtendedDAO dao;

  public AbstractGeodataOrtSearch() {
    super();
  }

  public List<GeodataOrt> getSearchResult(GeodataOrtSearchParameters searchParameters, EagerLoadingCollector<GeodataOrt> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<GeodataOrt> querySearchResult(GeodataOrtSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
